3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
15 unset COMMIT_AUTHOR_EMAIL
16 unset COMMIT_AUTHOR_NAME
17 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
19 GIT_AUTHOR_EMAIL=author@example.com
20 GIT_AUTHOR_NAME='A U Thor'
21 unset GIT_COMMITTER_DATE
22 GIT_COMMITTER_EMAIL=committer@example.com
23 GIT_COMMITTER_NAME='C O Mitter'
26 unset GIT_EXTERNAL_DIFF
28 unset GIT_OBJECT_DIRECTORY
29 unset SHA1_FILE_DIRECTORIES
30 unset SHA1_FILE_DIRECTORY
31 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
32 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
34 # Each test should start with something like this, after copyright notices:
36 # test_description='Description of this test...
37 # This test checks if command xyzzy does the right thing...
51 test "${test_description}" != "" ||
52 error "Test script did not set test_description."
57 -d|--d|--de|--deb|--debu|--debug)
59 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
61 -h|--h|--he|--hel|--help)
62 echo "$test_description"
64 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
72 if test "$verbose" = "t"
76 exec 4>/dev/null 3>/dev/null
82 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
85 # You are not expected to call test_ok_ and test_failure_ directly, use
86 # the text_expect_* functions instead.
89 test_count=$(expr "$test_count" + 1)
90 say " ok $test_count: $@"
94 test_count=$(expr "$test_count" + 1)
95 test_failure=$(expr "$test_failure" + 1);
96 say "FAIL $test_count: $1"
98 echo "$@" | sed -e 's/^/ /'
99 test "$immediate" = "" || { trap - exit; exit 1; }
104 test "$debug" = "" || eval "$1"
113 test_expect_failure () {
115 error "bug in the test script: not 2 parameters to test-expect-failure"
116 say >&3 "expecting failure: $2"
118 if [ "$?" = 0 -a "$eval_ret" != 0 ]
126 test_expect_success () {
128 error "bug in the test script: not 2 parameters to test-expect-success"
129 say >&3 "expecting success: $2"
131 if [ "$?" = 0 -a "$eval_ret" = 0 ]
139 test_expect_code () {
141 error "bug in the test script: not 3 parameters to test-expect-code"
142 say >&3 "expecting exit code $1: $3"
144 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
154 case "$test_failure" in
157 # cd .. && rm -fr trash
158 # but that means we forbid any tests that use their own
159 # subdirectory from calling test_done without coming back
160 # to where they started from.
161 # The Makefile provided will clean this test area so
162 # we will leave things as they are.
164 say "passed all $test_count test(s)"
168 say "failed $test_failure among $test_count test(s)"
174 # Test the binaries we have just built. The tests are kept in
175 # t/ subdirectory and are run in trash subdirectory.
177 GIT_EXEC_PATH=$(pwd)/..
178 export PATH GIT_EXEC_PATH
180 # Similarly use ../compat/subprocess.py if our python does not
181 # have subprocess.py on its own.
185 }' ../git-merge-recursive` || {
186 error "You haven't built things yet, have you?"
188 "$PYTHON" -c 'import subprocess' 2>/dev/null || {
189 PYTHONPATH=$(pwd)/../compat
192 test -d ../templates/blt || {
193 error "You haven't built things yet, have you?"
200 cd "$test" || error "Cannot setup test environment"
201 "$GIT_EXEC_PATH/git" init-db --template=../../templates/blt/ 2>/dev/null ||
202 error "cannot run git init-db -- have you built things yet?"
204 mv .git/hooks .git/hooks-disabled